// UniversalTransition.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"

#include "SDIB32GL.H"
#include "fpstimer.h"
#include "util.h"

#define MEDIA_PATH( a )	"../Media/"a

struct _RULEINFO {
	char		szRuleName[256];
	BYTE		Vague;				// l
}RuleInfo;

const char* lpszBgName[] = { 
	MEDIA_PATH("OEh.jpg"), 
	MEDIA_PATH("ejXR[g.jpg"),
	MEDIA_PATH("t@~X.jpg"),
	MEDIA_PATH("t@~XX.jpg"),
	MEDIA_PATH(".jpg"),
	MEDIA_PATH("wH.jpg"),
	MEDIA_PATH(".jpg"),
	MEDIA_PATH("̓.jpg"),
	MEDIA_PATH("~.jpg"),
	MEDIA_PATH("EnL.jpg"),
	MEDIA_PATH("p.jpg"),
	MEDIA_PATH("{.jpg"),
};

LPSDIB32GL lpBack	= NULL;
LPSDIB32GL lpBg		= NULL;
LPSDIB32GL lpTransBg= NULL;
LPSDIB32GL lpRule	= NULL;
DWORD dwBgID	= 0;
DWORD dwTransBgID = 0;
const CLSID* pUse_CLSID;
extern CFpsTimer FpsTimer;
DWORD dwFilePos = 0;


void LoadRuleImage( void )
{
	// gWV`t@Cp[^ǂݍ
	FILE* fp = fopen( "trans.txt", "r" );

	if( !fp ) throw exception( "t@CI[vG[" );

	fseek( fp, dwFilePos, SEEK_SET );

	char buf[256];

	do
	{
		if( !fgets( buf, 256, fp ) )
		{
			rewind(fp);

			if( !fgets( buf, 256, fp ) )

				throw exception( "t@CG[" );
		}

	}while( buf[0] == ';' || buf[0] == '\n' );

	dwFilePos = ftell( fp );
	fclose( fp );

	sprintf( RuleInfo.szRuleName, "../../TransLib/%s", strtok( buf, " \n" ) );

	char* vague = strtok( NULL, " \n" );

	if( vague )
	{
		RuleInfo.Vague = atoi( vague );
	}else
	{
		RuleInfo.Vague = 32;
	}

	// [obt@̉
	if( lpRule ){ lpRule->Release(); lpRule = NULL; }

	HRESULT hr;

	// [摜̓ǂݍ
	hr = SDIB32GL_LoadFromFile( RuleInfo.szRuleName, 0, NULL,
		*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpRule );

	if( FAILED( hr ) )
	{
		throw exception("[摜̓ǂݍ݂Ɏs܂");
	}

}


void SwapBackGround( void )
{

	// gWVobt@Ɍ݂BGʂRs[
	lpTransBg->Blt( lpBg, 0, 0, NULL, NULL, NULL );
	
	DWORD max_bg = sizeof(lpszBgName)/sizeof(char*);
	DWORD tmp;

	do
	{
		tmp = rand()%max_bg;

	}while( tmp == dwBgID || tmp == dwTransBgID );

	dwTransBgID = dwBgID;
	dwBgID = tmp;

	// BGobt@̉
	lpBg->Release(); lpBg = NULL;

	HRESULT hr;

	// BGǂݍ
	hr = SDIB32GL_LoadFromFile( lpszBgName[dwBgID], 0, NULL,
		*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpBg );

	if( FAILED( hr ) )
	{
		throw exception("BG摜̓ǂݍ݂Ɏs");
	}
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
 	// TODO: ̈ʒuɃR[hLqĂB

	MyRegisterClass( hInstance );

	if( !InitInstance( hInstance, nCmdShow ) )
	{
		return FALSE;
	}


	// MMX̔
	BOOL bMMX = SDIB32GL_IsMMX();

	if( bMMX )
	{
		pUse_CLSID = &CLSID_SDib32GLPMMX;

	}else
	{
		pUse_CLSID = &CLSID_SDib32GLX86;
	}
	
	HRESULT hr;

	try
	{
		// obNobt@̍쐬
		hr = SDIB32GL_CreateBuffer( 
			CLIENT_WIDTH, CLIENT_HEIGHT, SDIB32GL_BLUE, NULL,
			*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpBack );

		if( FAILED( hr ) )
		{
			throw exception("obNobt@̍쐬Ɏs");
		}

		// BGǂݍ
		hr = SDIB32GL_LoadFromFile(
			lpszBgName[dwBgID], 0, NULL,
			*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpBg );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}

		// gWVobt@̍쐬
		hr = SDIB32GL_CreateBuffer( 
			CLIENT_WIDTH, CLIENT_HEIGHT, 0, NULL,
			*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpTransBg );

		if( FAILED( hr ) )
		{
			throw exception("gWVobt@̍쐬Ɏs");
		}

	}


	// G[
	catch( exception& e )
	{
		
		MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );

		if( lpTransBg ){	lpTransBg->Release(); lpTransBg = NULL; }
		if( lpBg ){		lpBg->Release(); lpBg = NULL; }
		if( lpBack ){	lpBack->Release(); lpBack = NULL; }

		return FALSE;
	}

	// bZ[W[v(C[`)
	MSG msg;
	DWORD dwPhase = 0;
	bool bTransition = false;
	char szBuf[256];

	for(;;)
	{
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{
			if( msg.message == WM_QUIT ) break;

			TranslateMessage( &msg );
			DispatchMessage( &msg );

		}else
		{

			// BG`
			lpBack->Blt( lpBg, 0, 0, NULL, NULL, NULL );

			if( !bTransition )
			{
				try
				{
					if( GetActiveWindow() == hWnd )
					{
						if( GetAsyncKeyState( VK_LBUTTON )&0x8000 )
						{
							LoadRuleImage();

							SwapBackGround();

							bTransition = true;
							dwPhase = 0;

						}else if( GetAsyncKeyState( VK_RBUTTON )&0x8000 )
						{
							if( lpRule )
							{
								SwapBackGround();

								bTransition = true;
								dwPhase = 0;
							}
						}
					}
				}

				catch( exception& e )
				{
					MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );
					PostMessage( hWnd, WM_CLOSE, 0, 0 );
				}

				sprintf( szBuf, "Next>> ENbN, Replay>> NbN" );

			}else
			{

				// gWV`
				lpBack->UniversalTransBlt( 
					lpTransBg, 0, 0, NULL, NULL, NULL, 
					lpRule, dwPhase, RuleInfo.Vague, 0 );

				// 2bŐ؂ւ (1bԂɉZl*t[oߎ)
				dwPhase += 32768*FpsTimer.GetElapsed();

				if( dwPhase > 65535 )
				{
					bTransition = false;
				}

				sprintf( szBuf, "Phase=%3d%% Rule=\"%s\" Vague=%d", (dwPhase*100/65535), RuleInfo.szRuleName, RuleInfo.Vague );
			}


			SetBkMode( lpBack->GetDC(), TRANSPARENT );
			SetTextColor( lpBack->GetDC(), RGB(80,80,80) );
			TextOut( lpBack->GetDC(), 2, 452, szBuf, strlen(szBuf));
			SetTextColor( lpBack->GetDC(), RGB(255,255,255) );
			TextOut( lpBack->GetDC(), 0, 450, szBuf, strlen(szBuf));

			// FPSAMMXAo[W̕`
			DrawSDib32GLInfo( lpBack );

			// ĕ`
			InvalidateRect( hWnd, NULL, FALSE );
			UpdateWindow( hWnd );
		}
	}

	// [obt@̉
	if( lpRule ){ lpRule->Release(); lpRule = NULL; }

	// gWVobt@̉
	if( lpTransBg ){ lpTransBg->Release(); lpTransBg = NULL; }

	// BGobt@̉
	lpBg->Release();
	lpBg = NULL;

	// obNobt@̉
	lpBack->Release();
	lpBack = NULL;

	return msg.wParam;
}


//
// ʂ̃tbV
//
void OnRefresh( HDC hdc )
{
	if( lpBack == NULL ) return;

	BitBlt( hdc, 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT, 
		lpBack->GetDC(), 0, 0, SRCCOPY );
}


